package com.gyf.csams

import io.ktor.application.*
import io.ktor.features.*
import io.ktor.gson.*
import io.ktor.http.*

fun main(args: Array<String>): Unit = io.ktor.server.netty.EngineMain.main(args)

@Suppress("unused") // Referenced in application.conf
@kotlin.jvm.JvmOverloads
fun Application.module(testing: Boolean = false) {
    install(CORS) {
        method(HttpMethod.Options)
        method(HttpMethod.Put)
        method(HttpMethod.Delete)
        method(HttpMethod.Patch)
        header(HttpHeaders.Authorization)
        header("MyCustomHeader")
        allowCredentials = true
        anyHost() // @TODO: Don't do this in production if possible. Try to limit it.
    }

    install(ContentNegotiation) {
        gson()
    }

    install(CallLogging)
}


fun Application.Controller(testing: Boolean = false){
    StaticController()
    AccountController()
    TestController()
    MainController()
    AssociationController()
    NotificationController()

    /**
     * 初始化log
     */
    listOf(MainService,AccountService,FileService,AssociationService,BackgroundService,NotificationService).forEach {
        it.init(environment)
    }
}


